<!-- #include virtual="/AspLib/inc.asp" --><%
function boot(route) {
	allowCORS(env("HTTP_ORIGIN"));
	if(env("REQUEST_METHOD") == "OPTIONS") return;
	sys.showApi = true;
	sys.name = "无服务器 ASP 云函数";
	sys.dbPath = "App_Data\\Index.sdf";
	sys.route = route;
	sys.dir = env("URL").replace(/[^\/]+$/, "");
	sys.ns = sys.dir.toLowerCase(); try {
	var rs = execApi(initApi(route) || {}, 0);
	return rs instanceof Object ? tojson(rs) : rs;
	} catch(err) { return initDb(err, route); }
}

function initApi(route) {
	if(!route[0]) route[0] = "Index";
	var user = sys.app = route.shift();
	if(!route[0]) route[0] = "Index";
	var manager = ss(sys.ns + "api.admin." + user.toLowerCase());
	var root = {
		moreapp: function() {
			var nextid = ~~form("nextid");
			var table = "apps";
			if(nextid) table += " where id<=" + nextid;
			return db().table(table).orderby("id desc").select("top 16 id, app, intro, regtime").query();
		},
		// 编辑代码
		editcode: function() {
			var app = manager.app;
			if(!app) return this.regapi();
			var id = ~~route[1];
			switch(form("op")) {
				case "Save": return save();
				case "Drop": return drop();
			}
			// 保存函数
			function save() {
				var data = form(); data.app = app;
				delete data.op; delete data.toString;
				if(!id) db().insert("funcs", data);
				else db().update("funcs", data, { id: id, app: app });
				return { msg: "保存成功" };
			}
			// 删除函数
			function drop() {
				return db().query("delete from funcs where id=@id and app=@app", { id: id, app: app }), { msg: "删除成功" };
			}
			var rs = !id ? { code: "function() {}" } : db().fetch("select * from funcs where id=@id and app=@app", { id: id, app: app });
			if(!rs) return { err: "函数不存在" };
			%><!-- #include file="views/editcode.html" --><%
		},
		// 导出源码
		exportsource: function() {
			var app = manager.app;
			if(!app) return this.regapi();
			var arr = [ "Memo: []" ];
			funcs.forEach(function(x) {
				var api = x.name.toLowerCase();
				if(api != "init") arr.push(x.name + "Doc: " + tojson([ x.remark, x.args ]));
				arr.push(api + ": " + x.code);
			});
			Response.AddHeader("Content-Disposition", "attachment; filename=default.asp");
			return lib("/AspLib/lib/File.sct").readText("views/export.txt").replace("/* API 定义 */", arr.join(",\r\n"));
		},
		// 校验密码
		apppass: function() {
			var app = db().fetch("select * from apps where app=@app and pass=@pass", {
				app: form().app, pass: md5(form().pass, 16)
			});
			if(!app) return { err: "登录失败" };
			manager.app = app.app;
			return { app: app.app };
		},
		// 用户登录
		login: function() { %><!-- #include file="views/login.html" --><% },
		// 保存 App 信息
		saveapp: function() {
			var data = form();
			var user = data.app;
			data.pass = md5(data.pass, 16);
			// 判断 app 是否存在
			var app = db().fetch("select * from apps where app=@app", { app: user });
			if(!app) return db().insert("apps", data), { msg: "注册成功" };
			if(app.pass != data.pass) return { err: "密码错误" };
			db().update("apps", { intro: data.intro }, { app: user });
			return { msg: "更新成功" };
		},
		// App 注册页面
		regapi: function() { %><!-- #include file="views/regapi.html" --><% },
		home: function() { %><!-- #include file="views/home.html" --><% },
		// 自动跳至 API 目录
		index: function() { return redir("?r=" + user + "/Api"); }
	};
	var code = new Object, api = new Object;
	var par = { app: user.toLowerCase() };
	var funcs = db().table("funcs").where("app=@app").query(par);
	funcs.forEach(function(x) {
		var key = x.name.toLowerCase();
		code[x.name] = x.code;
		var str = manager.app ? " " + "[编辑]".link("?r=" + user + "/EditCode/" + x.id) : "";
		// 非管理员不公开 init 方法
		if(key != "init" || manager.app) api[x.name + "Doc" ] = [ x.remark + str, x.args ];
		try { api[key] = (new Function("return " + x.code))(); }
		catch(err) { api[key] = function() { return "异常代码：\r\n" + x.code }; }
		api[key].toString = function() { return x.code.replace(/\n\t/g, "\n"); };
	});
	api.Memo = [ manager.app ? "导出源码".link("?r=" + manager.app + "/ExportSource") + " | " + "新建函数".link("?r=" + manager.app + "/EditCode") +
		" （Init 函数仅对管理员可见，且自动执行，用于初始化敏感参数）": "管理登录".link("?r=" + user + "/Login") ];
	var app = db().fetch("select * from apps where app=@app", par);
	if(!app) api.index = function() { return redir("?r=/RegApi"); };
	else sys.name = app.intro;
	// 自动初始化处理
	if(route[0].toLowerCase() == "api") {
		sys.ns += user.toLowerCase() + "/";
		sys.dbPath = "App_Data\\" + user + ".sdf";
		if(api.init) api.init();
	}
	root.api = api;
	return root;
}

// 执行 Api 
function execApi(model, dep) {
	var api = (sys.route[dep] || "index").toLowerCase();
	if(!model[api]) return api == "index" ? showApi.call(model) : { err: "404 Object not found." };
	return "function" == typeof model[api] ? model[api]() : execApi(model[api], -~dep);
}

// 显示 Api 文档页
function showApi() {
	if(!sys.showApi) return { err: "404 Object not found." };
	sys.apipath = (qstr("r") || "");
	if(sys.apipath) sys.apipath += "/";
	sys.apipath = "?r=" + sys.apipath;
	delete Array.prototype.forEach;
	%><!-- #include virtual="/AspLib/views/apidoc.html" --><%
}

// 跨域处理
function allowCORS(origin) {
	if(!origin) return;
	Response.AddHeader("Access-Control-Allow-Credentials", "true");
	Response.AddHeader("Access-Control-Allow-Methods", "GET,POST");
	Response.AddHeader("Access-Control-Allow-Headers", "content-type");
	Response.AddHeader("Access-Control-Allow-Origin", origin);
}

// 数据库初始化
function initDb(err, route) {
	if(err.number != -2147217865) return tojson({ err: err.message, cmd: db().lastSql });
	if(route[0].toLowerCase() == "api") return tojson({ err: err.message, cmd: db().lastSql });
	if(sys.hasTry) return tojson({ err: "建表异常" });
	sys.hasTry = true;
	// 应用表
	db().create("apps", [
		[ "id int", null, true ], "app nvarchar(16), pass nchar(16), intro nvarchar(254)", [ "regtime datetime", "getdate()" ]
	]);
	// 函数表
	db().create("funcs", [
		[ "id int", null, true ], "app nvarchar(16), [name] nvarchar(32), remark nvarchar(32), args nvarchar(254), [code] ntext"
	]);
	return boot(route);
}
%>